%%%
%%% Authors:
%%%   Erik Klintskog (erik.klintskog@sics.se)
%%%
%%% Copyright:
%%%   Erik Klintskog, 2000
%%%
%%% Last change:
%%%   $Date: 2000/11/15 15:10:27 $ by $Author: nilsf $
%%%   $Revision: 1.2 $
%%%
%%% See the file "LICENSE" or
%%%    http://mozart.ps.uni-sb.de/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

functor
import
   Misc(vecAdd:VecAdd
	vecSub:VecSub
	vecMul:VecMul
	%%dist:Dist
	vecNorm:VecNorm
	%%vecNormalize:VecNormalize
	%%vecNormalizeNorm:VecNormalizeNorm
       )

export
   Animate

define
   class FillInDefaultVals
      feat val
      meth parameters(maxStep:M <= 40.0 gravity:G <= ~80.0  spring:S <= 40.0 friction:F<=0.5 strong:Str<=none)
	 self.val = parameters(maxStep:M
			       gravity:G
			       spring:S
			       friction:F
			       strong:Str
			      )
      end
   end
   
   
   proc{MoveNodes Time Nodes AttractPoints FixedNodes Parameters}
      if Time > 0.0 then MS UserTime 
	 NodeForce = Parameters.gravity
	 MaxDist = Parameters.maxStep
	 Brake = 1.0  - Parameters.friction
	 SpringForce = Parameters.spring
	 
      in
	 {ForAll Nodes proc{$ N} {N setDspeed(0.0#0.0)} end}
	 {List.forAllTail Nodes
	  proc{$ F|R}
	     Links = {F getLinks($)}
	     ForceMul = case Parameters.strong of none then 1.0
			elseof linear then {IntToFloat {Length Links}+1}
			elseof square then {Pow {IntToFloat {Length Links}+1} 2.0}
			end
	     FMassCentras = {Map {F getMassCentras($)}
			     fun{$ MC}
				{VecAdd {F getRealCoord($)}MC}
			     end}
	     FForceDiv = 1.0 / {IntToFloat {Length FMassCentras}}
	  in
	     {ForAll R proc{$ N}
			  RMassCentras = {Map {N getMassCentras($)}
					  fun{$ MC}
					     {VecAdd {N getRealCoord($)}MC}
					  end}
			  RForceDiv = 1.0 / {IntToFloat {Length RMassCentras}}
		       in
			  {ForAll FMassCentras
			   proc{$ FP}
			      {N attract(point:FP
					 force:NodeForce *ForceMul *FForceDiv
					 type:counter_square)}
			   end}
			  {ForAll RMassCentras
			   proc{$ RP}
			      {F attract(point:RP
					 force:NodeForce*ForceMul *RForceDiv
					 type:counter_square)}
			   end}
		       end}
	     {ForAll Links
	      proc{$ N}
		 {F attract(point:{N getRealCoord($)}
			    force:SpringForce
			    type:linear)}
		 {N attract(point:{F getRealCoord($)}
			    force:SpringForce
			    type:linear)}
	      end}
	  end}
	 {ForAll AttractPoints
	  proc{$ attract(point:P force:F type:T)}
	     {ForAll Nodes
	      proc{$ N}
		 {N attract(point:P force:F type:T)}
	      end}
	  end}
	 {ForAll FixedNodes proc{$ N}
			       {N setSpeed(0.0#0.0)}
			       {N setDspeed(0.0#0.0)}
			    end}
	 MS = {FoldL Nodes
	       fun{$ M O}
		  Speed = {VecNorm{VecAdd {O getSpeed($)} {O getDspeed($)}}}
	       in
		  {Max M Speed *  Brake}
	       end MaxDist}
	 UserTime =  {Min Time MaxDist / MS }
%	 {System.show t(time:Time userTime:UserTime maxDist:MaxDist maxSpeed:MS)} 
		  
	 {ForAll Nodes proc{$ N}
			  SV =  {VecAdd {N getSpeed($)} {VecMul UserTime {N getDspeed($)}}}
		       in
			  {N setSpeed({VecMul  Brake SV})}
			  {N setRealCoord({VecAdd {VecMul UserTime{N getSpeed($)}}
					   {N getRealCoord($)}})}
		       end}
	 {MoveNodes Time - UserTime Nodes AttractPoints FixedNodes Parameters}
      end
   end
   
   proc{Animate Nodes AttractPoints FixedNodes Parameters Moved}
      {MoveNodes 1.0 Nodes AttractPoints FixedNodes
       {New FillInDefaultVals Parameters}.val}
      Moved = {Filter Nodes fun{$ N}
			       {VecNorm {VecSub {N getCoord($)} {N getRealCoord($)}}} > 1.0 end}
   end
end


 
