%%%
%%% Authors:
%%%   Erik Klintskog (erik.klintskog@sics.se)
%%%
%%% Copyright:
%%%   Erik Klintskog, 2000
%%%
%%% Last change:
%%%   $Date: 2000/11/15 15:10:27 $ by $Author: nilsf $
%%%   $Revision: 1.2 $
%%%
%%% See the file "LICENSE" or
%%%    http://mozart.ps.uni-sb.de/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

functor
import
    Misc(%%vecAdd:VecAdd
	 vecSub:VecSub
	 vecMul:VecMul
	 %%dist:Dist
	 %%vecNorm:VecNorm
	 %%vecNormalize:VecNormalize
	 vecNormalizeNorm:VecNormalizeNorm)

export
   Node

define
   class Node
      attr
	 realCoord
	 coord
	 dSpeed:0.0#0.0
	 speed:0.0#0.0
	 links:nil
	 massCentras:[0.0#0.0]
      meth setDspeed(S) dSpeed <- S end
      meth getDspeed($) @dSpeed end 
      meth getSpeed($) @speed end
      meth setSpeed(S) speed <- S end 
      meth getRealCoord($) @realCoord end
      meth setRealCoord(R) realCoord<-R end
      meth getCoord($) @coord end
      meth setCoord(C) coord <- C  end
      meth getLinks($) @links end
      meth setLinks(S) links <- S end 
      meth getMassCentras($) @massCentras end
      meth setMassCentras(S) massCentras<-S end
      meth attract(point:P force:F type:T) V VN D Res in
	 V = {VecSub @realCoord  P}
	 VN = {VecNormalizeNorm V D}
	 case T of linear then 
	    Res = {VecMul  D *F  VN}
	 elseof counter_linear then
	    Res = {VecMul  F/D  VN}
	 elseof square then
	    Res = {VecMul {Pow D 2.0} * F  VN} 
	 elseof counter_square then 
	    Res = {VecMul F / {Pow D 2.0}  VN} 
	 end
	 dSpeed <- {VecSub @dSpeed Res}
      end
   end
end
   
