%%%
%%% Authors:
%%%   Erik Klintskog (erik.klintskog@sics.se)
%%%
%%% Copyright:
%%%   Erik Klintskog, 2000
%%%
%%% Last change:
%%%   $Date: 2000/11/15 15:10:27 $ by $Author: nilsf $
%%%   $Revision: 1.2 $
%%%
%%% See the file "LICENSE" or
%%%    http://mozart.ps.uni-sb.de/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

functor
import
   OS
export
   VecAdd
   VecSub
   VecMul
   Dist
   VecNorm
   VecNormalizeNorm
   VecNormalize
   RandBetween
   RandListElement
%   Assert
define
   fun {VecAdd V1 V2}  (V1.1+V2.1)#(V1.2+V2.2) end
   fun {VecSub V1 V2}  (V1.1-V2.1)#(V1.2-V2.2) end
   fun {VecMul K V}    (K*V.1)#(K*V.2) end
   fun {Dist P1 P2}  {VecNorm {VecSub P1 P2}} end
   fun {VecNorm V1} {Sqrt {Pow V1.1 2.0} + {Pow V1.2 2.0}} end
   fun {VecNormalize V} N ={VecNorm V} in
      if N == 0.0 then V
      else
	 {VecMul 1.0/N V}
      end
   end
   fun{VecNormalizeNorm V N}
      N ={VecNorm V}
      if N == 0.0 then V
      else
	 {VecMul 1.0/N V}
      end
   end
   fun {RandBetween X Y} ({OS.rand} mod (Y-X+1))+X end
%   proc{Assert B Txt}
%      if {Not B} then
%	 {System.showInfo Txt}
%	 Txt = apa
%	 end 
%   end
   fun{RandListElement R}
      LL = {Length R}
   in
      {Nth R {RandBetween 1 LL}}
   end
end
